/* A Bison parser, made by GNU Bison 3.4.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 11 "bpf_parser.y"


#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <signal.h>
#include <stdint.h>
#include <errno.h>
#include <libgen.h>
#include <linux/filter.h>

#include "bpf.h"
#include "str.h"
#include "xmalloc.h"
#include "bpf_parser.tab.h"
#include "built_in.h"
#include "die.h"
#include "cpp.h"

static int curr_instr = 0;

static struct sock_filter out[BPF_MAXINSNS];

static char *labels[BPF_MAXINSNS];
static char *labels_jt[BPF_MAXINSNS];
static char *labels_jf[BPF_MAXINSNS];
static char *labels_k[BPF_MAXINSNS];

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYLTYPE_IS_TRIVIAL	1

extern FILE *yyin;
extern int yylex(void);
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

static inline void check_max_instr(void)
{
	if (curr_instr >= BPF_MAXINSNS)
		panic("Exceeded maximal number of instructions!\n");
}

static inline void set_curr_instr(uint16_t code, uint8_t jt, uint8_t jf, uint32_t k)
{
	check_max_instr();

	out[curr_instr].code = code;
	out[curr_instr].jt = jt;
	out[curr_instr].jf = jf;
	out[curr_instr].k = k;

	curr_instr++;
}

static inline void set_curr_label(char *label)
{
	check_max_instr();

	labels[curr_instr] = label;
}

#define JTL		1
#define JFL		2
#define JKL		3

static inline void set_jmp_label(char *label, int which)
{
	check_max_instr();

	switch (which) {
	case JTL:
		labels_jt[curr_instr] = label;
		break;
	case JFL:
		labels_jf[curr_instr] = label;
		break;
	case JKL:
		labels_k[curr_instr] = label;
		break;
	default:
		bug();
	}
}

static int find_intr_offset_or_panic(char *label_to_search)
{
	int i, max = curr_instr, ret = -ENOENT;

	bug_on(!label_to_search);

	for (i = 0; i < max; ++i) {
		if (labels[i] != NULL) {
			/* Both are \0-terminated! */
			if (!strcmp(label_to_search, labels[i])) {
				ret = i;
				break;
			}
		}
	}

	if (ret == -ENOENT)
		panic("No such label!\n");

	return ret;
}


#line 180 "bpfc/bpf_parser.tab.c"

# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_BPFC_BPF_PARSER_TAB_H_INCLUDED
# define YY_YY_BPFC_BPF_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    OP_LDB = 258,
    OP_LDH = 259,
    OP_LD = 260,
    OP_LDX = 261,
    OP_ST = 262,
    OP_STX = 263,
    OP_JMP = 264,
    OP_JEQ = 265,
    OP_JGT = 266,
    OP_JGE = 267,
    OP_JSET = 268,
    OP_ADD = 269,
    OP_SUB = 270,
    OP_MUL = 271,
    OP_DIV = 272,
    OP_AND = 273,
    OP_OR = 274,
    OP_XOR = 275,
    OP_LSH = 276,
    OP_RSH = 277,
    OP_RET = 278,
    OP_TAX = 279,
    OP_TXA = 280,
    OP_LDXB = 281,
    OP_MOD = 282,
    OP_NEG = 283,
    OP_JNEQ = 284,
    OP_JLT = 285,
    OP_JLE = 286,
    OP_LDI = 287,
    OP_LDXI = 288,
    K_PKT_LEN = 289,
    K_PROTO = 290,
    K_TYPE = 291,
    K_NLATTR = 292,
    K_NLATTR_NEST = 293,
    K_MARK = 294,
    K_QUEUE = 295,
    K_HATYPE = 296,
    K_RXHASH = 297,
    K_CPU = 298,
    K_IFIDX = 299,
    K_VLANT = 300,
    K_VLANP = 301,
    K_POFF = 302,
    number = 303,
    label = 304
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 121 "bpf_parser.y"

	char *label;
	long int number;

#line 278 "bpfc/bpf_parser.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_BPFC_BPF_PARSER_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  181
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   388

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  64
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  36
/* YYNRULES -- Number of rules.  */
#define YYNRULES  171
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  352

#define YYUNDEFTOK  2
#define YYMAXUTOK   304

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    60,     2,    61,    59,     2,
      52,    53,    58,    56,    49,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    48,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    57,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    51,     2,     2,     2,    55,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      54,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    62,    63
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   144,   144,   145,   149,   150,   154,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   191,   195,   197,
     199,   201,   204,   207,   210,   213,   216,   219,   222,   225,
     228,   231,   234,   237,   243,   245,   247,   249,   252,   255,
     258,   261,   264,   267,   270,   273,   276,   279,   282,   285,
     291,   293,   298,   300,   302,   305,   308,   311,   314,   317,
     320,   323,   326,   329,   332,   335,   338,   341,   343,   345,
     347,   352,   354,   359,   361,   363,   365,   370,   378,   383,
     388,   394,   398,   402,   406,   409,   412,   418,   421,   424,
     430,   433,   436,   442,   445,   448,   454,   458,   462,   466,
     469,   472,   478,   482,   486,   490,   493,   496,   502,   506,
     510,   514,   517,   520,   526,   528,   530,   535,   537,   539,
     544,   546,   548,   553,   555,   557,   562,   564,   566,   571,
     576,   578,   580,   585,   587,   589,   594,   596,   598,   603,
     605,   607,   612,   614,   616,   621,   623,   625,   627,   629,
     634,   639
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "OP_LDB", "OP_LDH", "OP_LD", "OP_LDX",
  "OP_ST", "OP_STX", "OP_JMP", "OP_JEQ", "OP_JGT", "OP_JGE", "OP_JSET",
  "OP_ADD", "OP_SUB", "OP_MUL", "OP_DIV", "OP_AND", "OP_OR", "OP_XOR",
  "OP_LSH", "OP_RSH", "OP_RET", "OP_TAX", "OP_TXA", "OP_LDXB", "OP_MOD",
  "OP_NEG", "OP_JNEQ", "OP_JLT", "OP_JLE", "OP_LDI", "OP_LDXI",
  "K_PKT_LEN", "K_PROTO", "K_TYPE", "K_NLATTR", "K_NLATTR_NEST", "K_MARK",
  "K_QUEUE", "K_HATYPE", "K_RXHASH", "K_CPU", "K_IFIDX", "K_VLANT",
  "K_VLANP", "K_POFF", "':'", "','", "'['", "']'", "'('", "')'", "'x'",
  "'a'", "'+'", "'M'", "'*'", "'&'", "'#'", "'%'", "number", "label",
  "$accept", "prog", "line", "labelled_instr", "instr", "labelled", "ldb",
  "ldh", "ldi", "ld", "ldxi", "ldx", "st", "stx", "jmp", "jeq", "jneq",
  "jlt", "jle", "jgt", "jge", "jset", "add", "sub", "mul", "div", "mod",
  "neg", "and", "or", "xor", "lsh", "rsh", "ret", "tax", "txa", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    58,    44,
      91,    93,    40,    41,   120,    97,    43,    77,    42,    38,
      35,    37,   303,   304
};
# endif

#define YYPACT_NINF -54

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-54)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      61,    60,   124,     1,   123,   -23,    -3,   -13,    59,   118,
     121,   130,   132,   134,   142,   144,   146,   154,   156,   158,
     166,    57,   -54,   -54,    47,   168,   -54,   170,   178,   180,
      -7,    96,    14,     0,   -54,   -54,   -54,   122,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,    -5,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,    -2,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
      54,    64,   111,   -54,    71,   114,    65,    72,   127,   -54,
     138,   135,   145,   140,   139,   155,   162,   151,   167,   174,
     163,   179,   -54,   173,   182,   -54,   175,   188,   -54,   181,
     190,   -54,   183,   192,   -54,   185,   194,   -54,   187,   196,
     -54,   189,   198,   -54,   191,   200,   -54,   193,   202,   -54,
     -54,   195,   -53,   201,   -54,   199,   204,   211,   203,   208,
     214,   205,   210,   217,   206,   215,   209,   -54,   212,   -54,
     -54,   -54,   -54,   -54,   216,   219,   224,   220,   223,   227,
     225,   226,   228,   221,   -54,   222,   -54,   218,   229,   230,
     231,   233,   236,   232,   237,   238,   234,   239,   240,   235,
     241,   244,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   247,   -54,   -54,   242,   251,   252,   243,
     253,   254,   245,   255,   258,   -54,   -54,   248,   256,   -54,
     249,   257,   -54,   259,   260,   -54,   263,   264,   246,   266,
     267,   270,   261,   262,   271,   265,   268,   273,   269,   272,
     274,   275,   276,   277,   -54,   278,   279,   -54,   280,   281,
     -54,   282,   283,   285,   286,   289,   287,   296,   288,   -54,
     -54,   290,   -54,   -54,   291,   284,   302,   292,   304,   307,
     294,   309,   310,   297,   312,   313,   301,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   314,   -54,   315,   -54,   316,   317,
     -54,   306,   308,   -54,   311,   318,   -54,   319,   320,   -54,
     321,   322,   324,   -54,   -54,   -54,   250,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   305,   325,   326,   323,   327,
     -54,   -54
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   170,   171,     0,     0,   149,     0,     0,     0,
       0,     0,     0,     0,     2,     5,     4,     0,     7,     8,
      10,     9,    12,    11,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    41,    42,
      44,    45,    46,    47,    48,    49,    50,    43,    51,    52,
      53,     0,    57,    58,    60,    61,    62,    63,    64,    65,
      66,    59,    67,    68,    69,     0,    73,    74,    75,    77,
      78,    79,    80,    81,    82,    83,    76,    84,    85,    86,
       0,     0,     0,    94,     0,     0,     0,     0,     0,   100,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   135,     0,     0,   138,     0,     0,   141,     0,
       0,   144,     0,     0,   151,     0,     0,   154,     0,     0,
     157,     0,     0,   160,     0,     0,   163,     0,     0,   167,
     165,     0,     0,     0,   147,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,     0,    92,
      37,     1,     3,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    72,     0,    93,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   134,   136,   137,   139,   140,   142,   143,   145,
     150,   152,   153,   155,   156,   158,   159,   161,   162,   164,
     169,   168,   166,     0,   146,   148,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    70,    91,     0,     0,    40,
       0,     0,    56,     0,     0,    90,     0,     0,     0,     0,
       0,   105,     0,     0,   120,     0,     0,   126,     0,     0,
     132,     0,     0,     0,   108,     0,     0,   111,     0,     0,
     114,     0,     0,     0,     0,     0,     0,     0,     0,    87,
      95,     0,    98,    99,     0,   104,   106,     0,   119,   121,
       0,   125,   127,     0,   131,   133,     0,   107,   109,   110,
     112,   113,   115,    38,     0,    54,     0,    88,     0,     0,
     102,     0,     0,   117,     0,     0,   123,     0,     0,   129,
       0,     0,     0,    39,    55,    89,     0,   101,   103,   116,
     118,   122,   124,   128,   130,     0,     0,     0,     0,     0,
      97,    96
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -54,   -54,   293,   -54,   300,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
     181,   231,   232,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,   117,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   184,
     119,   110,   187,   176,   118,   177,   185,   186,   111,   188,
     189,   112,   180,    32,     1,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,   190,   163,
      81,   159,   160,   120,   193,   191,   192,   161,   162,   121,
     122,   195,   198,   197,    32,     1,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   178,   113,   179,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,   123,   194,    95,   126,   196,   199,   124,   125,
     114,   127,   128,   115,   129,   116,   132,   200,   135,   203,
     130,   131,   133,   134,   136,   137,   138,   201,   141,   202,
     144,   204,   139,   140,   142,   143,   145,   146,   147,   205,
     150,   206,   153,   207,   148,   149,   151,   152,   154,   155,
     156,   208,   164,   209,   167,   210,   157,   158,   165,   166,
     168,   169,   170,   211,   173,   212,   213,   214,   171,   172,
     174,   175,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   235,   233,
     236,   234,   238,   239,   241,   237,   242,   240,   243,   244,
     258,   245,   247,   248,   246,   249,   250,   251,   252,   255,
     254,   253,   262,   256,   257,   263,   265,   266,   268,   269,
     271,   259,   260,   272,   261,   264,   291,   267,   270,   273,
     275,   276,   278,   279,   281,   274,   277,   282,   280,   346,
     283,   285,   284,   286,   289,   290,   288,   292,   293,   294,
     297,   287,   300,   303,   295,   296,   182,   306,   298,     0,
       0,   299,   301,   321,     0,   302,   313,   183,   304,   305,
     315,   307,   308,   309,   310,   311,   312,   317,   314,   316,
     318,   322,   319,   324,   320,   323,   325,   326,   327,   328,
     329,   330,   331,   332,   347,   333,   334,   335,   336,   337,
       0,   338,     0,     0,   339,   345,   350,     0,     0,     0,
     351,   340,   341,   342,   343,   344,     0,   348,   349
};

static const yytype_int8 yycheck[] =
{
       0,    54,    55,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    57,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    54,
      63,    50,    54,    60,    57,    62,    61,    62,    57,    61,
      62,    60,    48,    63,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    54,    62,
      50,    54,    55,    54,    50,    61,    62,    60,    61,    60,
      61,    50,    50,    58,    63,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    60,    34,    62,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    54,    62,    50,    54,    62,    50,    60,    61,
      57,    60,    61,    60,    54,    62,    54,    49,    54,    49,
      60,    61,    60,    61,    60,    61,    54,    62,    54,    54,
      54,    62,    60,    61,    60,    61,    60,    61,    54,    54,
      54,    49,    54,    62,    60,    61,    60,    61,    60,    61,
      54,    54,    54,    49,    54,    62,    60,    61,    60,    61,
      60,    61,    54,    54,    54,    62,    54,    62,    60,    61,
      60,    61,    54,    62,    54,    62,    54,    62,    54,    62,
      54,    62,    54,    62,    54,    62,    54,    62,    54,    58,
      49,    62,    54,    49,    54,    62,    49,    62,    62,    54,
      52,    62,    56,    54,    62,    51,    56,    54,    51,    51,
      54,    56,    49,    62,    62,    49,    49,    49,    49,    49,
      49,    62,    62,    49,    63,    63,    50,    63,    63,    52,
      49,    49,    49,    49,    49,    63,    63,    49,    63,    59,
      62,    62,    56,    56,    51,    51,    56,    51,    51,    49,
      49,    62,    49,    49,    63,    63,    33,    50,    63,    -1,
      -1,    63,    63,    49,    -1,    63,    51,    37,    63,    63,
      51,    63,    63,    63,    63,    63,    63,    51,    62,    62,
      62,    49,    62,    49,    63,    63,    49,    63,    49,    49,
      63,    49,    49,    62,    59,    51,    51,    51,    51,    63,
      -1,    63,    -1,    -1,    63,    51,    53,    -1,    -1,    -1,
      53,    63,    63,    63,    63,    63,    -1,    62,    62
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    63,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    50,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    50,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      50,    57,    60,    34,    57,    60,    62,    57,    57,    63,
      54,    60,    61,    54,    60,    61,    54,    60,    61,    54,
      60,    61,    54,    60,    61,    54,    60,    61,    54,    60,
      61,    54,    60,    61,    54,    60,    61,    54,    60,    61,
      54,    60,    61,    54,    60,    61,    54,    60,    61,    54,
      55,    60,    61,    62,    54,    60,    61,    54,    60,    61,
      54,    60,    61,    54,    60,    61,    60,    62,    60,    62,
      48,     0,    66,    68,    54,    61,    62,    54,    61,    62,
      54,    61,    62,    50,    62,    50,    62,    58,    50,    50,
      49,    62,    54,    49,    62,    54,    49,    62,    54,    49,
      62,    54,    62,    54,    62,    54,    62,    54,    62,    54,
      62,    54,    62,    54,    62,    54,    62,    54,    62,    54,
      62,    54,    55,    58,    62,    54,    49,    62,    54,    49,
      62,    54,    49,    62,    54,    62,    62,    56,    54,    51,
      56,    54,    51,    56,    54,    51,    62,    62,    52,    62,
      62,    63,    49,    49,    63,    49,    49,    63,    49,    49,
      63,    49,    49,    52,    63,    49,    49,    63,    49,    49,
      63,    49,    49,    62,    56,    62,    56,    62,    56,    51,
      51,    50,    51,    51,    49,    63,    63,    49,    63,    63,
      49,    63,    63,    49,    63,    63,    50,    63,    63,    63,
      63,    63,    63,    51,    62,    51,    62,    51,    62,    62,
      63,    49,    49,    63,    49,    49,    63,    49,    49,    63,
      49,    49,    62,    51,    51,    51,    51,    63,    63,    63,
      63,    63,    63,    63,    63,    51,    59,    59,    62,    62,
      53,    53
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    64,    65,    65,    66,    66,    67,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    69,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      72,    72,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    74,    74,    75,    75,    75,    75,    75,    76,    77,
      78,    79,    79,    79,    79,    79,    79,    80,    80,    80,
      81,    81,    81,    82,    82,    82,    83,    83,    83,    83,
      83,    83,    84,    84,    84,    84,    84,    84,    85,    85,
      85,    85,    85,    85,    86,    86,    86,    87,    87,    87,
      88,    88,    88,    89,    89,    89,    90,    90,    90,    91,
      92,    92,    92,    93,    93,    93,    94,    94,    94,    95,
      95,    95,    96,    96,    96,    97,    97,    97,    97,    97,
      98,    99
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     6,     7,
       4,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     6,     7,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     3,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     5,     6,     7,
       4,     3,     2,     3,     2,     5,    10,    10,     5,     5,
       2,     7,     6,     7,     5,     4,     5,     5,     4,     5,
       5,     4,     5,     5,     4,     5,     7,     6,     7,     5,
       4,     5,     7,     6,     7,     5,     4,     5,     7,     6,
       7,     5,     4,     5,     3,     2,     3,     3,     2,     3,
       3,     2,     3,     3,     2,     3,     3,     2,     3,     1,
       3,     2,     3,     3,     2,     3,     3,     2,     3,     3,
       2,     3,     3,     2,     3,     2,     3,     2,     3,     3,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 37:
#line 191 "bpf_parser.y"
    { set_curr_label((yyvsp[-1].label)); }
#line 1619 "bpfc/bpf_parser.tab.c"
    break;

  case 38:
#line 195 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_IND, 0, 0, (yyvsp[-1].number)); }
#line 1626 "bpfc/bpf_parser.tab.c"
    break;

  case 39:
#line 197 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_IND, 0, 0, (yyvsp[-1].number)); }
#line 1633 "bpfc/bpf_parser.tab.c"
    break;

  case 40:
#line 199 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0, (yyvsp[-1].number)); }
#line 1640 "bpfc/bpf_parser.tab.c"
    break;

  case 41:
#line 201 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PROTOCOL); }
#line 1648 "bpfc/bpf_parser.tab.c"
    break;

  case 42:
#line 204 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PKTTYPE); }
#line 1656 "bpfc/bpf_parser.tab.c"
    break;

  case 43:
#line 207 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_IFINDEX); }
#line 1664 "bpfc/bpf_parser.tab.c"
    break;

  case 44:
#line 210 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR); }
#line 1672 "bpfc/bpf_parser.tab.c"
    break;

  case 45:
#line 213 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR_NEST); }
#line 1680 "bpfc/bpf_parser.tab.c"
    break;

  case 46:
#line 216 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_MARK); }
#line 1688 "bpfc/bpf_parser.tab.c"
    break;

  case 47:
#line 219 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_QUEUE); }
#line 1696 "bpfc/bpf_parser.tab.c"
    break;

  case 48:
#line 222 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_HATYPE); }
#line 1704 "bpfc/bpf_parser.tab.c"
    break;

  case 49:
#line 225 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_RXHASH); }
#line 1712 "bpfc/bpf_parser.tab.c"
    break;

  case 50:
#line 228 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_CPU); }
#line 1720 "bpfc/bpf_parser.tab.c"
    break;

  case 51:
#line 231 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_VLAN_TAG); }
#line 1728 "bpfc/bpf_parser.tab.c"
    break;

  case 52:
#line 234 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_VLAN_TAG_PRESENT); }
#line 1736 "bpfc/bpf_parser.tab.c"
    break;

  case 53:
#line 237 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PAY_OFFSET); }
#line 1744 "bpfc/bpf_parser.tab.c"
    break;

  case 54:
#line 243 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_IND, 0, 0, (yyvsp[-1].number)); }
#line 1751 "bpfc/bpf_parser.tab.c"
    break;

  case 55:
#line 245 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_IND, 0, 0, (yyvsp[-1].number)); }
#line 1758 "bpfc/bpf_parser.tab.c"
    break;

  case 56:
#line 247 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0, (yyvsp[-1].number)); }
#line 1765 "bpfc/bpf_parser.tab.c"
    break;

  case 57:
#line 249 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PROTOCOL); }
#line 1773 "bpfc/bpf_parser.tab.c"
    break;

  case 58:
#line 252 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PKTTYPE); }
#line 1781 "bpfc/bpf_parser.tab.c"
    break;

  case 59:
#line 255 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_IFINDEX); }
#line 1789 "bpfc/bpf_parser.tab.c"
    break;

  case 60:
#line 258 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR); }
#line 1797 "bpfc/bpf_parser.tab.c"
    break;

  case 61:
#line 261 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR_NEST); }
#line 1805 "bpfc/bpf_parser.tab.c"
    break;

  case 62:
#line 264 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_MARK); }
#line 1813 "bpfc/bpf_parser.tab.c"
    break;

  case 63:
#line 267 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_QUEUE); }
#line 1821 "bpfc/bpf_parser.tab.c"
    break;

  case 64:
#line 270 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_HATYPE); }
#line 1829 "bpfc/bpf_parser.tab.c"
    break;

  case 65:
#line 273 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_RXHASH); }
#line 1837 "bpfc/bpf_parser.tab.c"
    break;

  case 66:
#line 276 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_CPU); }
#line 1845 "bpfc/bpf_parser.tab.c"
    break;

  case 67:
#line 279 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_VLAN_TAG); }
#line 1853 "bpfc/bpf_parser.tab.c"
    break;

  case 68:
#line 282 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_VLAN_TAG_PRESENT); }
#line 1861 "bpfc/bpf_parser.tab.c"
    break;

  case 69:
#line 285 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PAY_OFFSET); }
#line 1869 "bpfc/bpf_parser.tab.c"
    break;

  case 70:
#line 291 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_IMM, 0, 0, (yyvsp[0].number)); }
#line 1876 "bpfc/bpf_parser.tab.c"
    break;

  case 71:
#line 293 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_IMM, 0, 0, (yyvsp[0].number)); }
#line 1883 "bpfc/bpf_parser.tab.c"
    break;

  case 72:
#line 298 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_IMM, 0, 0, (yyvsp[0].number)); }
#line 1890 "bpfc/bpf_parser.tab.c"
    break;

  case 73:
#line 300 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_LEN, 0, 0, 0); }
#line 1897 "bpfc/bpf_parser.tab.c"
    break;

  case 74:
#line 302 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PROTOCOL); }
#line 1905 "bpfc/bpf_parser.tab.c"
    break;

  case 75:
#line 305 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PKTTYPE); }
#line 1913 "bpfc/bpf_parser.tab.c"
    break;

  case 76:
#line 308 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_IFINDEX); }
#line 1921 "bpfc/bpf_parser.tab.c"
    break;

  case 77:
#line 311 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR); }
#line 1929 "bpfc/bpf_parser.tab.c"
    break;

  case 78:
#line 314 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR_NEST); }
#line 1937 "bpfc/bpf_parser.tab.c"
    break;

  case 79:
#line 317 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_MARK); }
#line 1945 "bpfc/bpf_parser.tab.c"
    break;

  case 80:
#line 320 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_QUEUE); }
#line 1953 "bpfc/bpf_parser.tab.c"
    break;

  case 81:
#line 323 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_HATYPE); }
#line 1961 "bpfc/bpf_parser.tab.c"
    break;

  case 82:
#line 326 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_RXHASH); }
#line 1969 "bpfc/bpf_parser.tab.c"
    break;

  case 83:
#line 329 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_CPU); }
#line 1977 "bpfc/bpf_parser.tab.c"
    break;

  case 84:
#line 332 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_VLAN_TAG); }
#line 1985 "bpfc/bpf_parser.tab.c"
    break;

  case 85:
#line 335 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_VLAN_TAG_PRESENT); }
#line 1993 "bpfc/bpf_parser.tab.c"
    break;

  case 86:
#line 338 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PAY_OFFSET); }
#line 2001 "bpfc/bpf_parser.tab.c"
    break;

  case 87:
#line 341 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_MEM, 0, 0, (yyvsp[-1].number)); }
#line 2008 "bpfc/bpf_parser.tab.c"
    break;

  case 88:
#line 343 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_IND, 0, 0, (yyvsp[-1].number)); }
#line 2015 "bpfc/bpf_parser.tab.c"
    break;

  case 89:
#line 345 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_IND, 0, 0, (yyvsp[-1].number)); }
#line 2022 "bpfc/bpf_parser.tab.c"
    break;

  case 90:
#line 347 "bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0, (yyvsp[-1].number)); }
#line 2029 "bpfc/bpf_parser.tab.c"
    break;

  case 91:
#line 352 "bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_IMM, 0, 0, (yyvsp[0].number)); }
#line 2036 "bpfc/bpf_parser.tab.c"
    break;

  case 92:
#line 354 "bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_IMM, 0, 0, (yyvsp[0].number)); }
#line 2043 "bpfc/bpf_parser.tab.c"
    break;

  case 93:
#line 359 "bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_IMM, 0, 0, (yyvsp[0].number)); }
#line 2050 "bpfc/bpf_parser.tab.c"
    break;

  case 94:
#line 361 "bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_W | BPF_LEN, 0, 0, 0); }
#line 2057 "bpfc/bpf_parser.tab.c"
    break;

  case 95:
#line 363 "bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_MEM, 0, 0, (yyvsp[-1].number)); }
#line 2064 "bpfc/bpf_parser.tab.c"
    break;

  case 96:
#line 365 "bpf_parser.y"
    {
		if ((yyvsp[-8].number) != 4 || (yyvsp[-1].number) != 0xf) {
			panic("ldxb offset not supported!\n");
		} else {
			set_curr_instr(BPF_LDX | BPF_MSH | BPF_B, 0, 0, (yyvsp[-4].number)); } }
#line 2074 "bpfc/bpf_parser.tab.c"
    break;

  case 97:
#line 370 "bpf_parser.y"
    {
		if ((yyvsp[-8].number) != 4 || (yyvsp[-1].number) != 0xf) {
			panic("ldxb offset not supported!\n");
		} else {
			set_curr_instr(BPF_LDX | BPF_MSH | BPF_B, 0, 0, (yyvsp[-4].number)); } }
#line 2084 "bpfc/bpf_parser.tab.c"
    break;

  case 98:
#line 378 "bpf_parser.y"
    {
		set_curr_instr(BPF_ST, 0, 0, (yyvsp[-1].number)); }
#line 2091 "bpfc/bpf_parser.tab.c"
    break;

  case 99:
#line 383 "bpf_parser.y"
    {
		set_curr_instr(BPF_STX, 0, 0, (yyvsp[-1].number)); }
#line 2098 "bpfc/bpf_parser.tab.c"
    break;

  case 100:
#line 388 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JKL);
		set_curr_instr(BPF_JMP | BPF_JA, 0, 0, 0); }
#line 2106 "bpfc/bpf_parser.tab.c"
    break;

  case 101:
#line 394 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_K, 0, 0, (yyvsp[-4].number)); }
#line 2115 "bpfc/bpf_parser.tab.c"
    break;

  case 102:
#line 398 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
#line 2124 "bpfc/bpf_parser.tab.c"
    break;

  case 103:
#line 402 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
#line 2133 "bpfc/bpf_parser.tab.c"
    break;

  case 104:
#line 406 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2141 "bpfc/bpf_parser.tab.c"
    break;

  case 105:
#line 409 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
#line 2149 "bpfc/bpf_parser.tab.c"
    break;

  case 106:
#line 412 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
#line 2157 "bpfc/bpf_parser.tab.c"
    break;

  case 107:
#line 418 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2165 "bpfc/bpf_parser.tab.c"
    break;

  case 108:
#line 421 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
#line 2173 "bpfc/bpf_parser.tab.c"
    break;

  case 109:
#line 424 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
#line 2181 "bpfc/bpf_parser.tab.c"
    break;

  case 110:
#line 430 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2189 "bpfc/bpf_parser.tab.c"
    break;

  case 111:
#line 433 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
#line 2197 "bpfc/bpf_parser.tab.c"
    break;

  case 112:
#line 436 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
#line 2205 "bpfc/bpf_parser.tab.c"
    break;

  case 113:
#line 442 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2213 "bpfc/bpf_parser.tab.c"
    break;

  case 114:
#line 445 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
#line 2221 "bpfc/bpf_parser.tab.c"
    break;

  case 115:
#line 448 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
#line 2229 "bpfc/bpf_parser.tab.c"
    break;

  case 116:
#line 454 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_K, 0, 0, (yyvsp[-4].number)); }
#line 2238 "bpfc/bpf_parser.tab.c"
    break;

  case 117:
#line 458 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
#line 2247 "bpfc/bpf_parser.tab.c"
    break;

  case 118:
#line 462 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
#line 2256 "bpfc/bpf_parser.tab.c"
    break;

  case 119:
#line 466 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2264 "bpfc/bpf_parser.tab.c"
    break;

  case 120:
#line 469 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
#line 2272 "bpfc/bpf_parser.tab.c"
    break;

  case 121:
#line 472 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
#line 2280 "bpfc/bpf_parser.tab.c"
    break;

  case 122:
#line 478 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_K, 0, 0, (yyvsp[-4].number)); }
#line 2289 "bpfc/bpf_parser.tab.c"
    break;

  case 123:
#line 482 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
#line 2298 "bpfc/bpf_parser.tab.c"
    break;

  case 124:
#line 486 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
#line 2307 "bpfc/bpf_parser.tab.c"
    break;

  case 125:
#line 490 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2315 "bpfc/bpf_parser.tab.c"
    break;

  case 126:
#line 493 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
#line 2323 "bpfc/bpf_parser.tab.c"
    break;

  case 127:
#line 496 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
#line 2331 "bpfc/bpf_parser.tab.c"
    break;

  case 128:
#line 502 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_K, 0, 0, (yyvsp[-4].number)); }
#line 2340 "bpfc/bpf_parser.tab.c"
    break;

  case 129:
#line 506 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_X, 0, 0, 0); }
#line 2349 "bpfc/bpf_parser.tab.c"
    break;

  case 130:
#line 510 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[-2].label), JTL);
		set_jmp_label((yyvsp[0].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_X, 0, 0, 0); }
#line 2358 "bpfc/bpf_parser.tab.c"
    break;

  case 131:
#line 514 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_K, 0, 0, (yyvsp[-2].number)); }
#line 2366 "bpfc/bpf_parser.tab.c"
    break;

  case 132:
#line 517 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_X, 0, 0, 0); }
#line 2374 "bpfc/bpf_parser.tab.c"
    break;

  case 133:
#line 520 "bpf_parser.y"
    {
		set_jmp_label((yyvsp[0].label), JTL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_X, 0, 0, 0); }
#line 2382 "bpfc/bpf_parser.tab.c"
    break;

  case 134:
#line 526 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_ADD | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2389 "bpfc/bpf_parser.tab.c"
    break;

  case 135:
#line 528 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_ADD | BPF_X, 0, 0, 0); }
#line 2396 "bpfc/bpf_parser.tab.c"
    break;

  case 136:
#line 530 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_ADD | BPF_X, 0, 0, 0); }
#line 2403 "bpfc/bpf_parser.tab.c"
    break;

  case 137:
#line 535 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_SUB | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2410 "bpfc/bpf_parser.tab.c"
    break;

  case 138:
#line 537 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_SUB | BPF_X, 0, 0, 0); }
#line 2417 "bpfc/bpf_parser.tab.c"
    break;

  case 139:
#line 539 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_SUB | BPF_X, 0, 0, 0); }
#line 2424 "bpfc/bpf_parser.tab.c"
    break;

  case 140:
#line 544 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MUL | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2431 "bpfc/bpf_parser.tab.c"
    break;

  case 141:
#line 546 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MUL | BPF_X, 0, 0, 0); }
#line 2438 "bpfc/bpf_parser.tab.c"
    break;

  case 142:
#line 548 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MUL | BPF_X, 0, 0, 0); }
#line 2445 "bpfc/bpf_parser.tab.c"
    break;

  case 143:
#line 553 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_DIV | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2452 "bpfc/bpf_parser.tab.c"
    break;

  case 144:
#line 555 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_DIV | BPF_X, 0, 0, 0); }
#line 2459 "bpfc/bpf_parser.tab.c"
    break;

  case 145:
#line 557 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_DIV | BPF_X, 0, 0, 0); }
#line 2466 "bpfc/bpf_parser.tab.c"
    break;

  case 146:
#line 562 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MOD | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2473 "bpfc/bpf_parser.tab.c"
    break;

  case 147:
#line 564 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MOD | BPF_X, 0, 0, 0); }
#line 2480 "bpfc/bpf_parser.tab.c"
    break;

  case 148:
#line 566 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MOD | BPF_X, 0, 0, 0); }
#line 2487 "bpfc/bpf_parser.tab.c"
    break;

  case 149:
#line 571 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_NEG, 0, 0, 0); }
#line 2494 "bpfc/bpf_parser.tab.c"
    break;

  case 150:
#line 576 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_AND | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2501 "bpfc/bpf_parser.tab.c"
    break;

  case 151:
#line 578 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_AND | BPF_X, 0, 0, 0); }
#line 2508 "bpfc/bpf_parser.tab.c"
    break;

  case 152:
#line 580 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_AND | BPF_X, 0, 0, 0); }
#line 2515 "bpfc/bpf_parser.tab.c"
    break;

  case 153:
#line 585 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_OR | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2522 "bpfc/bpf_parser.tab.c"
    break;

  case 154:
#line 587 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_OR | BPF_X, 0, 0, 0); }
#line 2529 "bpfc/bpf_parser.tab.c"
    break;

  case 155:
#line 589 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_OR | BPF_X, 0, 0, 0); }
#line 2536 "bpfc/bpf_parser.tab.c"
    break;

  case 156:
#line 594 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_XOR | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2543 "bpfc/bpf_parser.tab.c"
    break;

  case 157:
#line 596 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_XOR | BPF_X, 0, 0, 0); }
#line 2550 "bpfc/bpf_parser.tab.c"
    break;

  case 158:
#line 598 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_XOR | BPF_X, 0, 0, 0); }
#line 2557 "bpfc/bpf_parser.tab.c"
    break;

  case 159:
#line 603 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_LSH | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2564 "bpfc/bpf_parser.tab.c"
    break;

  case 160:
#line 605 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_LSH | BPF_X, 0, 0, 0); }
#line 2571 "bpfc/bpf_parser.tab.c"
    break;

  case 161:
#line 607 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_LSH | BPF_X, 0, 0, 0); }
#line 2578 "bpfc/bpf_parser.tab.c"
    break;

  case 162:
#line 612 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_RSH | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2585 "bpfc/bpf_parser.tab.c"
    break;

  case 163:
#line 614 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_RSH | BPF_X, 0, 0, 0); }
#line 2592 "bpfc/bpf_parser.tab.c"
    break;

  case 164:
#line 616 "bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_RSH | BPF_X, 0, 0, 0); }
#line 2599 "bpfc/bpf_parser.tab.c"
    break;

  case 165:
#line 621 "bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_A, 0, 0, 0); }
#line 2606 "bpfc/bpf_parser.tab.c"
    break;

  case 166:
#line 623 "bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_A, 0, 0, 0); }
#line 2613 "bpfc/bpf_parser.tab.c"
    break;

  case 167:
#line 625 "bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_X, 0, 0, 0); }
#line 2620 "bpfc/bpf_parser.tab.c"
    break;

  case 168:
#line 627 "bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_X, 0, 0, 0); }
#line 2627 "bpfc/bpf_parser.tab.c"
    break;

  case 169:
#line 629 "bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_K, 0, 0, (yyvsp[0].number)); }
#line 2634 "bpfc/bpf_parser.tab.c"
    break;

  case 170:
#line 634 "bpf_parser.y"
    {
		set_curr_instr(BPF_MISC | BPF_TAX, 0, 0, 0); }
#line 2641 "bpfc/bpf_parser.tab.c"
    break;

  case 171:
#line 639 "bpf_parser.y"
    {
		set_curr_instr(BPF_MISC | BPF_TXA, 0, 0, 0); }
#line 2648 "bpfc/bpf_parser.tab.c"
    break;


#line 2652 "bpfc/bpf_parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 643 "bpf_parser.y"


static void stage_1_inline(void)
{
	yyparse();
}

static void stage_2_label_reduce(void)
{
	int i, max = curr_instr, off;

	/* 1. reduce k jumps */
	for (i = 0; i < max; ++i) {
		if (labels_k[i] != NULL) {
			off = find_intr_offset_or_panic(labels_k[i]);
			out[i].k = (uint32_t) (off - i - 1);
		}
	}

	/* 1. reduce jt jumps */
	for (i = 0; i < max; ++i) {
		if (labels_jt[i] != NULL) {
			off = find_intr_offset_or_panic(labels_jt[i]);
			out[i].jt = (uint8_t) (off - i -1);
		}
	}

	/* 1. reduce jf jumps */
	for (i = 0; i < max; ++i) {
		if (labels_jf[i] != NULL) {
			off = find_intr_offset_or_panic(labels_jf[i]);
			out[i].jf = (uint8_t) (off - i - 1);
		}
	}
}

static void pretty_printer_c(const struct sock_fprog *prog)
{
	int i;

	for (i = 0; i < prog->len; ++i) {
		printf("{ 0x%x, %u, %u, 0x%08x },\n",
		       prog->filter[i].code, prog->filter[i].jt,
		       prog->filter[i].jf, prog->filter[i].k);
	}
}

static void pretty_printer_xt_bpf(const struct sock_fprog *prog)
{
	int i;

	printf("%d,", prog->len);
	for (i = 0; i < prog->len; ++i) {
		printf("%u %u %u %u,",
		       prog->filter[i].code, prog->filter[i].jt,
		       prog->filter[i].jf, prog->filter[i].k);
	}

	fflush(stdout);
}

static void pretty_printer_tcpdump(const struct sock_fprog *prog)
{
	int i;

	for (i = 0; i < prog->len; ++i) {
		printf("%u %u %u %u\n",
		       prog->filter[i].code, prog->filter[i].jt,
		       prog->filter[i].jf, prog->filter[i].k);
	}
}

static void pretty_printer(const struct sock_fprog *prog, int format)
{
	switch (format) {
	case 0:
		pretty_printer_c(prog);
		break;
	case 1:
		pretty_printer_xt_bpf(prog);
		break;
	case 2:
		pretty_printer_tcpdump(prog);
		break;
	default:
		bug();
	}
}

int compile_filter(char *file, bool verbose, int bypass, int format,
		   bool invoke_cpp, char *const cpp_argv[])
{
	int i;
	struct sock_fprog res;
	char tmp_file[128];
	int ret = 0;

	memset(tmp_file, 0, sizeof(tmp_file));

	if (invoke_cpp) {
		ret = cpp_exec(file, tmp_file, sizeof(tmp_file), cpp_argv);
		if (ret) {
			fprintf(stderr, "Failed to invoke C preprocessor!\n");
			goto exit;
		}

		file = tmp_file;
	}

	if (!strncmp("-", file, strlen("-")))
		yyin = stdin;
	else
		yyin = fopen(file, "r");
	if (!yyin)
		panic("Cannot open file!\n");

	memset(out, 0, sizeof(out));
	memset(labels, 0, sizeof(labels));
	memset(labels_jf, 0, sizeof(labels_jf));
	memset(labels_jt, 0, sizeof(labels_jt));
	memset(labels_k, 0, sizeof(labels_k));

	stage_1_inline();
	stage_2_label_reduce();

	res.filter = out;
	res.len = curr_instr;

	if (verbose) {
		printf("Generated program:\n");
		bpf_dump_all(&res);
	}

	if (!bypass) {
		if (verbose) {
			printf("Validating: ");
			fflush(stdout);
		}

		if (__bpf_validate(&res) == 0) {
			if (verbose)
				printf("Semantic error! BPF validation failed!\n");
			else {
				printf("Semantic error! BPF validation failed! "
				       "Try -V for debugging output!\n");
				ret = 1;
				goto exit;
			}
		} else if (verbose) {
			printf("is runnable!\n");
		}
	}

	if (verbose)
		printf("Result:\n");

	pretty_printer(&res, format);

	for (i = 0; i < res.len; ++i) {
		free(labels[i]);
		free(labels_jt[i]);
		free(labels_jf[i]);
		free(labels_k[i]);
	}

	if (yyin && yyin != stdin)
		fclose(yyin);

exit:
	if (invoke_cpp)
		unlink(tmp_file);

	return ret;
}

void yyerror(const char *err)
{
	panic("Syntax error at line %d: %s! %s!\n",
	      yylineno, yytext, err);
}
